<?php
if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', './../../');

define('FORUM_SKIP_CSRF_CONFIRM', 1);
define('FORUM_DISABLE_CSRF_CONFIRM', 1);

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/topic.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/post.php';

if (isset($_GET['action']))
	define('FORUM_QUIET_VISIT', 1);

$hooks_enable = true; //Enable hooks

if (defined('BLACK_LIST_LOADED')) {
	$use_black_list = true; //Enable blacklist
    if ($use_black_list == true && !empty($forum_user['black_list']) && ($forum_user['blacklist_hiding_option'] == '1' || $forum_user['blacklist_hiding_topics'] == '1'))
	    $black_list = unserialize($forum_user['black_list']);
}

$action = isset($_GET['action']) ? $_GET['action'] : null;

if ($action == 'get_new_post')
{
    $post_id = isset($_GET['cur_post_id']) ? intval($_GET['cur_post_id']) : 0;
	$last_post_id = isset($_GET['last_post_id']) ? intval($_GET['last_post_id']) : 0;
	$topic_id = isset($_GET['topic_id']) ? intval($_GET['topic_id']) : 0;
	$page = isset($_GET['page']) ? $_GET['page'] : null;
	$last_id = isset($_GET['last_id']) ? intval($_GET['last_id']) : 0;
	$posts_notifications = ajax_pu_get_posts_notifications();
	$last_post_date = ajax_pu_get_last_post_date();

	if ($post_id > 0 && $last_post_id > 0 && $topic_id > 0) {
		
		$query_check_post = array(
		    'SELECT' => 'p.id',
		    'FROM'	 => 'posts AS p',
			'WHERE'	 => 'p.topic_id='.$topic_id.' AND p.id>'.$last_post_id,
			'LIMIT'	 => 1
	    );
		
		if (isset($black_list)) {
		    $query_check_post['WHERE'] .= ' AND p.poster_id NOT IN ('.implode(',', $black_list).')';
	    }
		
		$result_check_post = $forum_db->query_build($query_check_post) or error(__FILE__, __LINE__);
		
		if ($forum_db->num_rows($result_check_post) > 0) {
			
			$new_posts_count = ajax_pu_get_new_posts_count();
			
			if ($page == 'viewtopic') {
			    if ($post_id != $last_post_id || ($post_id == $last_post_id && $forum_user['ajax_posts_update_enable'] != '1')) {
				    $query = array(
		                'SELECT'	=> 'p.posted',
		                'FROM'		=> 'posts AS p',
		                'WHERE'		=> 'p.id='.$post_id
	                );
	                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                $topic_info = $forum_db->fetch_assoc($result);
		
		            $query = array(
		                'SELECT'	=> 'COUNT(p.id)',
		                'FROM'		=> 'posts AS p',
		                'WHERE'		=> 'p.topic_id='.$topic_id.' AND p.posted<'.$topic_info['posted']
	                );
	                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                $num_posts = $forum_db->result($result) + 1;

				    $query = array(
		                'SELECT'	=> 't.subject, t.num_replies',
		                'FROM'		=> 'topics AS t',
		                'WHERE'		=> 't.id='.$topic_id
	                );
	                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	                $cur_topic = $forum_db->fetch_assoc($result);

	                $p = ceil($num_posts / $forum_user['disp_posts']);
		            $forum_page['num_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
                    $forum_page['page'] = (!isset($p) || !is_numeric($p) || $p <= 1 || $p > $forum_page['num_pages']) ? 1 : $p;
                    $forum_page['start_from'] = $forum_user['disp_posts'] * ($forum_page['page'] - 1);
                    $forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_posts']), ($cur_topic['num_replies'] + 1));
                    $info = generate_items_info($lang_topic['Posts'], ($forum_page['start_from'] + 1), ($cur_topic['num_replies'] + 1));
					$info = preg_replace("|<span class=\"item-info\">(.*?)</span>|is", "$1", $info);

                    if ($forum_page['page'] < $forum_page['num_pages'])
                    {
	                    $forum_page['nav']['last'] = '<link rel="last" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], $forum_page['num_pages'], array($topic_id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
	                    $forum_page['nav']['next'] = '<link rel="next" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], ($forum_page['page'] + 1), array($topic_id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
                    }
                    if ($forum_page['page'] > 1)
                    {
	                    $forum_page['nav']['prev'] = '<link rel="prev" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], ($forum_page['page'] - 1), array($topic_id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
	                    $forum_page['nav']['first'] = '<link rel="first" href="'.forum_link($forum_url['topic'], array($topic_id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' 1" />';
                    }

                    if ($forum_config['o_censoring'] == '1')
	                    $cur_topic['subject'] = censor_words($cur_topic['subject']);

                    $paging = '<span class="pages">'.$lang_common['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['topic'], $lang_common['Paging separator'], array($topic_id, sef_friendly($cur_topic['subject']))).'';
                    $l_post_id = ajax_pu_get_last_post_id();
				    
					echo json_encode(array('answer'=>1,'info'=>$info,'paginate'=>$paging,'new_posts_count'=>$new_posts_count,'last_id'=>$l_post_id,'notify'=>$posts_notifications,'last_entry'=>$last_post_date));
				
	                die;
				} elseif ($post_id == $last_post_id && $forum_user['ajax_posts_update_enable'] == '1') {
				
				    if (!defined('FORUM_PAGE')) define('FORUM_PAGE', $page);
				    if ($hooks_enable) {
					    ($hook = get_hook('hd_head')) ? eval($hook) : null;
				        ($hook = get_hook('vt_start')) ? eval($hook) : null;
					}
				
				    $id = $topic_id;
				    $pid = false;
				
				    $query = array(
		                'SELECT'	=> 't.subject, t.first_post_id, t.closed, t.num_replies, t.sticky, f.id AS forum_id, f.forum_name, f.moderators, fp.post_replies',
		                'FROM'		=> 'posts AS p',
			            'JOINS'		=>  array(
				            array(
				                'INNER JOIN'	=> 'topics AS t',
				                'ON'			=> 't.id=p.topic_id'
			                ),
					        array(
			                    'INNER JOIN'	=> 'forums AS f',
			                    'ON'			=> 'f.id=t.forum_id'
		                    ),
					        array(
			                    'LEFT JOIN'		=> 'forum_perms AS fp',
			                    'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
		                    )
		                ),
//			            'WHERE'	=> 'p.topic_id='.$id.' AND p.id='.$post_id
					    'WHERE'	=> 'p.id='.$post_id
	                );
			
			        if ($forum_config['o_subscriptions'] == '1')
                    {
	                    $query['SELECT'] .= ', s.user_id AS is_subscribed';
	                    $query['JOINS'][] = array(
		                    'LEFT JOIN'	=> 'subscriptions AS s',
		                    'ON'		=> '(p.topic_id=s.topic_id AND s.user_id='.$forum_user['id'].')'
	                    );
                    }
		
		            if ($hooks_enable) {
					    ($hook = get_hook('vt_qr_get_topic_info')) ? eval($hook) : null;
					} else {
						$query['SELECT'] .= ', t.last_post_id';
					}
	                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
			        $cur_topic = $forum_db->fetch_assoc($result);
			        
					if ($hooks_enable) {
			            ($hook = get_hook('vt_modify_topic_info')) ? eval($hook) : null;
					}

                    $mods_array = ($cur_topic['moderators'] != '') ? unserialize($cur_topic['moderators']) : array();
                    $forum_page['is_admmod'] = ($forum_user['g_id'] == FORUM_ADMIN || ($forum_user['g_moderator'] == '1' && array_key_exists($forum_user['username'], $mods_array))) ? true : false;

                    $tracked_topics = get_tracked_topics();
	                $tracked_topics['topics'][$id] = time();
	                set_tracked_topics($tracked_topics);

		            $num_posts = $cur_topic['num_replies'] + 1;
	                $p = ceil($num_posts / $forum_user['disp_posts']);
		
		            $forum_page['num_pages'] = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
                    $forum_page['page'] = (!isset($p) || !is_numeric($p) || $p <= 1 || $p > $forum_page['num_pages']) ? 1 : $p;
                    $forum_page['start_from'] = $forum_user['disp_posts'] * ($forum_page['page'] - 1);
                    $forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_posts']), ($cur_topic['num_replies'] + 1));
					$info = generate_items_info($lang_topic['Posts'], ($forum_page['start_from'] + 1), ($cur_topic['num_replies'] + 1));
					$info = preg_replace("|<span class=\"item-info\">(.*?)</span>|is", "$1", $info);

				    if ($hooks_enable) {
					    ($hook = get_hook('vt_modify_page_details')) ? eval($hook) : null;
					}

                    if ($forum_page['page'] < $forum_page['num_pages'])
                    {
	                    $forum_page['nav']['last'] = '<link rel="last" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], $forum_page['num_pages'], array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.$forum_page['num_pages'].'" />';
	                    $forum_page['nav']['next'] = '<link rel="next" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], ($forum_page['page'] + 1), array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($forum_page['page'] + 1).'" />';
                    }
                    if ($forum_page['page'] > 1)
                    {
	                    $forum_page['nav']['prev'] = '<link rel="prev" href="'.forum_sublink($forum_url['topic'], $forum_url['page'], ($forum_page['page'] - 1), array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' '.($forum_page['page'] - 1).'" />';
	                    $forum_page['nav']['first'] = '<link rel="first" href="'.forum_link($forum_url['topic'], array($id, sef_friendly($cur_topic['subject']))).'" title="'.$lang_common['Page'].' 1" />';
                    }

                    if ($forum_config['o_censoring'] == '1')
	                    $cur_topic['subject'] = censor_words($cur_topic['subject']);

					$paging = '<span class="pages">'.$lang_common['Pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['topic'], $lang_common['Paging separator'], array($topic_id, sef_friendly($cur_topic['subject']))).'';

				    if ($hooks_enable) {
					    ($hook = get_hook('vt_pre_header_load')) ? eval($hook) : null;
					}

				    ob_start();

					if ($hooks_enable) {
                        ($hook = get_hook('vt_main_output_start')) ? eval($hook) : null;
					}

				    if (!defined('FORUM_PARSER_LOADED'))
	                    require FORUM_ROOT.'include/parser.php';

		            $forum_page['item_count'] = 0;

                    $query = array(
	                    'SELECT'	=> 'p.id',
	                    'FROM'		=> 'posts AS p',
	                    'WHERE'		=> 'p.topic_id='.$id,
	                    'ORDER BY'	=> 'p.id',
	                    'LIMIT'		=> $forum_page['start_from'].','.$forum_user['disp_posts']
                    );
				
				    if ($hooks_enable) {
					    ($hook = get_hook('vt_qr_get_posts_id')) ? eval($hook) : null;
					}
                    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

                    $posts_id = array();
                    while ($row = $forum_db->fetch_assoc($result)) {
	                    $posts_id[] = $row['id'];
                    }

		            $query = array(
		                'SELECT'	=> 'u.email, u.title, u.url, u.location, u.signature, u.email_setting, u.num_posts, u.registered, u.admin_note, u.avatar, u.avatar_width, u.avatar_height, p.id, p.poster AS username, p.poster_id, p.poster_ip, p.poster_email, p.message, p.hide_smilies, p.posted, p.edited, p.edited_by, p.topic_id, g.g_id, g.g_user_title, o.user_id AS is_online',
		                'FROM'		=> 'posts AS p',
		                'JOINS'		=>  array(
			                array(
				                'INNER JOIN'	=> 'users AS u',
				                'ON'			=> 'u.id=p.poster_id'
			                ),
			                array(
				                'INNER JOIN'	=> 'groups AS g',
				                'ON'			=> 'g.g_id=u.group_id'
			                ),
			                array(
				                'LEFT JOIN'		=> 'online AS o',
				                'ON'			=> '(o.user_id=u.id AND o.user_id!=1 AND o.idle=0)'
			                )
		                ),
                        'WHERE'		=> 'p.id IN ('.implode(',', $posts_id).')',
		                'ORDER BY'	=> 'p.id'
	                );

		            if ($hooks_enable) {
					    ($hook = get_hook('vt_qr_get_posts')) ? eval($hook) : null;
					}
	                $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

				    $user_data_cache = array();
                    while ( $cur_post = $forum_db->fetch_assoc($result)) {
				
				        if ($hooks_enable) {
						    ($hook = get_hook('vt_post_loop_start')) ? eval($hook) : null;
						}

                        ++$forum_page['item_count'];

		                $forum_page['post_ident'] = array();
		                $forum_page['author_ident'] = array();
		                $forum_page['author_info'] = array();
		                $forum_page['post_options'] = array();
		                $forum_page['post_contacts'] = array();
		                $forum_page['post_actions'] = array();
		                $forum_page['message'] = array();

		                $forum_page['post_ident']['num'] = '<span class="post-num">'.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span>';

		                if ($cur_post['poster_id'] > 1)
			                $forum_page['post_ident']['byline'] = '<span class="post-byline">'.sprintf((($cur_post['id'] == $cur_topic['first_post_id']) ? $lang_topic['Topic byline'] : $lang_topic['Reply byline']), (($forum_user['g_view_users'] == '1') ? '<a title="'.sprintf($lang_topic['Go to profile'], forum_htmlencode($cur_post['username'])).'" href="'.forum_link($forum_url['user'], $cur_post['poster_id']).'">'.forum_htmlencode($cur_post['username']).'</a>' : '<strong>'.forum_htmlencode($cur_post['username']).'</strong>')).'</span>';
		                else
			                $forum_page['post_ident']['byline'] = '<span class="post-byline">'.sprintf((($cur_post['id'] == $cur_topic['first_post_id']) ? $lang_topic['Topic byline'] : $lang_topic['Reply byline']), '<strong>'.forum_htmlencode($cur_post['username']).'</strong>').'</span>';

		                $forum_page['post_ident']['link'] = '<span class="post-link"><a class="permalink" rel="bookmark" title="'.$lang_topic['Permalink post'].'" href="'.forum_link($forum_url['post'], $cur_post['id']).'">'.format_time($cur_post['posted']).'</a></span>';

		                if ($cur_post['edited'] != '')
			                $forum_page['post_ident']['edited'] = '<span class="post-edit">'.sprintf($lang_topic['Last edited'], forum_htmlencode($cur_post['edited_by']), format_time($cur_post['edited'])).'</span>';
				
				        if ($hooks_enable) {
						    ($hook = get_hook('vt_row_pre_post_ident_merge')) ? eval($hook) : null;
						} else {
							if (!$forum_user['is_guest'] && ($forum_page['start_from'] + $forum_page['item_count']) == $forum_page['finish_at'])
	                            $forum_page['post_ident']['ajax-info'] = '<span class="post-ajax-info" cur_post="'.$cur_post['id'].'" last_post="'.$cur_topic['last_post_id'].'" topic="'.$id.'" style="display:none;"></span>';
						}
					
					    if (isset($user_data_cache[$cur_post['poster_id']]['author_ident']))
			                $forum_page['author_ident'] = $user_data_cache[$cur_post['poster_id']]['author_ident'];
		                else
		                {
				            if ($cur_post['poster_id'] > 1)
		                    {
			                    if ($forum_config['o_avatars'] == '1' && $forum_user['show_avatars'] != '0')
			                    {
				                    $forum_page['avatar_markup'] = generate_avatar_markup($cur_post['poster_id'], $cur_post['avatar'], $cur_post['avatar_width'], $cur_post['avatar_height'], $cur_post['username']);

				                    if (!empty($forum_page['avatar_markup']))
					                    $forum_page['author_ident']['avatar'] = '<li class="useravatar">'.$forum_page['avatar_markup'].'</li>';
			                    }

			                    $forum_page['author_ident']['username'] = '<li class="username">'.(($forum_user['g_view_users'] == '1') ? '<a title="'.sprintf($lang_topic['Go to profile'], forum_htmlencode($cur_post['username'])).'" href="'.forum_link($forum_url['user'], $cur_post['poster_id']).'">'.forum_htmlencode($cur_post['username']).'</a>' : '<strong>'.forum_htmlencode($cur_post['username']).'</strong>').'</li>';
			                    $forum_page['author_ident']['usertitle'] = '<li class="usertitle"><span>'.get_title($cur_post).'</span></li>';

			                    if ($cur_post['is_online'] == $cur_post['poster_id'])
				                    $forum_page['author_ident']['status'] = '<li class="userstatus"><span>'.$lang_topic['Online'].'</span></li>';
			                    else
				                    $forum_page['author_ident']['status'] = '<li class="userstatus"><span>'.$lang_topic['Offline'].'</span></li>';
		                    }
		                    else
		                    {
			                    $forum_page['author_ident']['username'] = '<li class="username"><strong>'.forum_htmlencode($cur_post['username']).'</strong></li>';
			                    $forum_page['author_ident']['usertitle'] = '<li class="usertitle"><span>'.get_title($cur_post).'</span></li>';
		                    }
					    }
					
					    if (isset($user_data_cache[$cur_post['poster_id']]['author_info']))
			                $forum_page['author_info'] = $user_data_cache[$cur_post['poster_id']]['author_info'];
		                else
		                {
		                    if ($cur_post['poster_id'] > 1)
		                    {
			                    if ($forum_config['o_show_user_info'] == '1')
			                    {
				                    if ($cur_post['location'] != '')
				                    {
					                    if ($forum_config['o_censoring'] == '1')
						                    $cur_post['location'] = censor_words($cur_post['location']);

					                    $forum_page['author_info']['from'] = '<li><span>'.$lang_topic['From'].' <strong>'.forum_htmlencode($cur_post['location']).'</strong></span></li>';
				                    }

				                    $forum_page['author_info']['registered'] = '<li><span>'.$lang_topic['Registered'].' <strong>'.format_time($cur_post['registered'], 1).'</strong></span></li>';

				                    if ($forum_config['o_show_post_count'] == '1' || $forum_user['is_admmod'])
					                    $forum_page['author_info']['posts'] = '<li><span>'.$lang_topic['Posts info'].' <strong>'.forum_number_format($cur_post['num_posts']).'</strong></span></li>';
			                    }

			                    if ($forum_user['is_admmod'])
			                    {
				                    if ($cur_post['admin_note'] != '')
					                    $forum_page['author_info']['note'] = '<li><span>'.$lang_topic['Note'].' <strong>'.forum_htmlencode($cur_post['admin_note']).'</strong></span></li>';
			                    }
		                    }
					    }

		                if ($forum_user['is_admmod'])
			                $forum_page['author_info']['ip'] = '<li><span>'.$lang_topic['IP'].' <a href="'.forum_link($forum_url['get_host'], $cur_post['id']).'">'.$cur_post['poster_ip'].'</a></span></li>';

		                if ($forum_config['o_show_user_info'] == '1')
		                {
			                if (isset($user_data_cache[$cur_post['poster_id']]['post_contacts']))
				                $forum_page['post_contacts'] = $user_data_cache[$cur_post['poster_id']]['post_contacts'];
			                else
			                {
						        if ($cur_post['poster_id'] > 1)
			                    {
				                    if ($cur_post['url'] != '')
					                    $forum_page['post_contacts']['url'] = '<span class="user-url'.(empty($forum_page['post_contacts']) ? ' first-item' : '').'"><a class="external" href="'.forum_htmlencode(($forum_config['o_censoring'] == '1') ? censor_words($cur_post['url']) : $cur_post['url']).'">'.sprintf($lang_topic['Visit website'], '<span>'.sprintf($lang_topic['User possessive'], forum_htmlencode($cur_post['username'])).'</span>').'</a></span>';
				                    if ((($cur_post['email_setting'] == '0' && !$forum_user['is_guest']) || $forum_user['is_admmod']) && $forum_user['g_send_email'] == '1')
					                    $forum_page['post_contacts']['email'] = '<span class="user-email'.(empty($forum_page['post_contacts']) ? ' first-item' : '').'"><a href="mailto:'.forum_htmlencode($cur_post['email']).'">'.$lang_topic['E-mail'].'<span>&#160;'.forum_htmlencode($cur_post['username']).'</span></a></span>';
				                    else if ($cur_post['email_setting'] == '1' && !$forum_user['is_guest'] && $forum_user['g_send_email'] == '1')
					                    $forum_page['post_contacts']['email'] = '<span class="user-email'.(empty($forum_page['post_contacts']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['email'], $cur_post['poster_id']).'">'.$lang_topic['E-mail'].'<span>&#160;'.forum_htmlencode($cur_post['username']).'</span></a></span>';
			                    }
			                    else
			                    {
				                    if ($cur_post['poster_email'] != '' && $forum_user['is_admmod'] && $forum_user['g_send_email'] == '1')
					                    $forum_page['post_contacts']['email'] = '<span class="user-email'.(empty($forum_page['post_contacts']) ? ' first-item' : '').'"><a href="mailto:'.forum_htmlencode($cur_post['poster_email']).'">'.$lang_topic['E-mail'].'<span>&#160;'.forum_htmlencode($cur_post['username']).'</span></a></span>';
			                    }
					        }
					
			                if ($hooks_enable) {
							    ($hook = get_hook('vt_row_pre_post_contacts_merge')) ? eval($hook) : null;
							}
					
					        if (!empty($forum_page['post_contacts']))
				                $forum_page['post_options']['contacts'] = '<p class="post-contacts">'.implode(' ', $forum_page['post_contacts']).'</p>';
		                }

		                if (!$forum_user['is_guest'])
		                {
			                $forum_page['post_actions']['report'] = '<span class="report-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['report'], $cur_post['id']).'">'.$lang_topic['Report'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';

			                if (!$forum_page['is_admmod'])
			                {
				                if ($cur_post['poster_id'] == $forum_user['id'])
					            {
						            if (($forum_page['start_from'] + $forum_page['item_count']) == 1 && $forum_user['g_delete_topics'] == '1')
							            $forum_page['post_actions']['delete'] = '<span class="delete-topic'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['delete'], $cur_topic['first_post_id']).'">'.$lang_topic['Delete topic'].'</a></span>';
						            if (($forum_page['start_from'] + $forum_page['item_count']) > 1 && $forum_user['g_delete_posts'] == '1')
							            $forum_page['post_actions']['delete'] = '<span class="delete-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['delete'], $cur_post['id']).'">'.$lang_topic['Delete'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
						            if ($forum_user['g_edit_posts'] == '1')
							            $forum_page['post_actions']['edit'] = '<span class="edit-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['edit'], $cur_post['id']).'">'.$lang_topic['Edit'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
					            }
						
						        $forum_page['post_actions']['quote'] = '<span class="quote-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['quote'], array($id, $cur_post['id'])).'">'.$lang_topic['Quote'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
			                } 
					        else
					        {
						        $forum_page['post_actions']['delete'] = '<span class="delete-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['delete'], $cur_post['id']).'">'.$lang_topic['Delete'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
				                $forum_page['post_actions']['edit'] = '<span class="edit-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['edit'], $cur_post['id']).'">'.$lang_topic['Edit'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
				                $forum_page['post_actions']['quote'] = '<span class="quote-post'.(empty($forum_page['post_actions']) ? ' first-item' : '').'"><a href="'.forum_link($forum_url['quote'], array($id, $cur_post['id'])).'">'.$lang_topic['Quote'].'<span> '.$lang_topic['Post'].' '.forum_number_format($forum_page['start_from'] + $forum_page['item_count']).'</span></a></span>';
					        }
		                }
				
				        if ($hooks_enable) {
						    ($hook = get_hook('vt_row_pre_post_actions_merge')) ? eval($hook) : null;
						}

		                if (!empty($forum_page['post_actions']))
			                $forum_page['post_options']['actions'] = '<p class="post-actions">'.implode(' ', $forum_page['post_actions']).'</p>';

		                $forum_page['item_status'] = array(
			                'post',
			                ($forum_page['item_count'] % 2 != 0) ? 'odd' : 'even'
		                );

                        if ($forum_page['item_count'] == 1)
			                $forum_page['item_status']['firstpost'] = 'firstpost';

		                if (($forum_page['start_from'] + $forum_page['item_count']) == $forum_page['finish_at'])
			                $forum_page['item_status']['lastpost'] = 'lastpost';

		                if ($cur_post['id'] == $cur_topic['first_post_id'])
			                $forum_page['item_status']['topicpost'] = 'topicpost';
		                else
			                $forum_page['item_status']['replypost'] = 'replypost';

		                if ($cur_post['id'] == $cur_topic['first_post_id'])
			                $forum_page['item_subject'] = sprintf($lang_topic['Topic title'], $cur_topic['subject']);
		                else
			                $forum_page['item_subject'] = sprintf($lang_topic['Reply title'], $cur_topic['subject']);

		                $forum_page['item_subject'] = forum_htmlencode($forum_page['item_subject']);

		                $forum_page['message']['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

		                if ($cur_post['signature'] != '' && $forum_user['show_sig'] != '0' && $forum_config['o_signatures'] == '1')
		                {
			                if (!isset($signature_cache[$cur_post['poster_id']]))
				                $signature_cache[$cur_post['poster_id']] = parse_signature($cur_post['signature']);

			                $forum_page['message']['signature'] = '<div class="sig-content"><span class="sig-line"><!-- --></span>'.$signature_cache[$cur_post['poster_id']].'</div>';
		                }
				
				        if ($hooks_enable) {
						    ($hook = get_hook('vt_row_pre_display')) ? eval($hook) : null;
						}
					
					    if ($cur_post['poster_id'] > 1 && !isset($user_data_cache[$cur_post['poster_id']]))
		                {
			                $user_data_cache[$cur_post['poster_id']] = array(
				                'author_ident'	=> $forum_page['author_ident'],
				                'author_info'	=> $forum_page['author_info'],
				                'post_contacts'	=> $forum_page['post_contacts']
			                );

			                if ($hooks_enable) {
							    ($hook = get_hook('vt_row_add_user_data_cache')) ? eval($hook) : null;
							}
		                }
?>
		                <div class="<?php echo implode(' ', $forum_page['item_status']) ?>">
			                <div id="p<?php echo $cur_post['id'] ?>" class="posthead">
				                <h3 class="hn post-ident"><?php echo implode(' ', $forum_page['post_ident']) ?></h3>
			                </div>
			                <div class="postbody<?php if ($cur_post['is_online'] == $cur_post['poster_id']) echo ' online'; ?>">
				                <div class="post-author">
					                <ul class="author-ident">
						                <?php echo implode("\n\t\t\t\t\t\t", $forum_page['author_ident'])."\n" ?>
					                </ul>
					                <ul class="author-info">
						                <?php echo implode("\n\t\t\t\t\t\t", $forum_page['author_info'])."\n" ?>
					                </ul>
				                </div>
				                <div class="post-entry">
					                <h4 id="pc<?php echo $cur_post['id'] ?>" class="entry-title hn"><?php echo $forum_page['item_subject'] ?></h4>
					                <div class="entry-content">
                                        <?php echo implode("\n\t\t\t\t\t\t", $forum_page['message'])."\n" ?>
					                </div>
                                    <?php if ($hooks_enable) { ($hook = get_hook('vt_row_new_post_entry_data')) ? eval($hook) : null; } ?>
				                </div>
			                </div>
                            <?php if (!empty($forum_page['post_options'])): ?>
			                    <div class="postfoot">
				                    <div class="post-options">
					                    <?php echo implode("\n\t\t\t\t\t", $forum_page['post_options'])."\n" ?>
				                    </div>
			                    </div>
                            <?php endif; ?>
		                </div>
<?php
		            }

				    $tpl_temp = forum_trim(ob_get_contents());
				    $tpl_main = '<!-- forum_main -->';
				    
					if ($hooks_enable) {
					    ($hook = get_hook('vt_end')) ? eval($hook) : null;
					}

					$tpl_main = preg_replace('#<div class="gen-content">.*?</div>#s', '', $tpl_main);
				    $tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
                    ob_end_clean();

					echo json_encode(array('answer'=>2,'info'=>$info,'paginate'=>$paging,'posts'=>$tpl_main,'new_posts_count'=>$new_posts_count,'notify'=>$posts_notifications,'last_entry'=>$last_post_date));
				
	                die;
			    }
		    } elseif ($page == 'post' && $forum_config['o_topic_review'] != '0') {
			
			    if (!defined('FORUM_PAGE')) define('FORUM_PAGE', $page);
				if ($hooks_enable) {
				    ($hook = get_hook('hd_head')) ? eval($hook) : null;
				    ($hook = get_hook('po_start')) ? eval($hook) : null;
				}
				
				$query = array(
		            'SELECT'	=> 't.forum_id AS id',
		            'FROM'		=> 'topics AS t',
		            'WHERE'		=> 't.id='.$topic_id
	            );
	            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	            $cur_posting = $forum_db->fetch_assoc($result);
				$forum_id = $cur_posting['id'];
				
				ob_start();

                if ($hooks_enable) {
				    ($hook = get_hook('po_main_output_start')) ? eval($hook) : null;
				}
				
                if (!defined('FORUM_PARSER_LOADED'))
		            require FORUM_ROOT.'include/parser.php';
                    
				$tid = $topic_id;

	            $query = array(
		            'SELECT'	=> 'count(p.id)',
		            'FROM'		=> 'posts AS p',
		            'WHERE'		=> 'topic_id='.$tid
	            );

	            if ($hooks_enable) {
				    ($hook = get_hook('po_topic_review_qr_get_post_count')) ? eval($hook) : null;
				}
	            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	            $forum_page['total_post_count'] = $forum_db->result($result, 0);

	            $query = array(
		            'SELECT'	=> 'p.id, p.poster, p.message, p.hide_smilies, p.posted',
		            'FROM'		=> 'posts AS p',
		            'WHERE'		=> 'topic_id='.$tid,
		            'ORDER BY'	=> 'id DESC',
		            'LIMIT'		=> $forum_config['o_topic_review']
	            );

	            if ($hooks_enable) {
				    ($hook = get_hook('po_topic_review_qr_get_topic_review_posts')) ? eval($hook) : null;
				}
	            $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	            $posts = array();
	            while ($cur_post = $forum_db->fetch_assoc($result))
	            {
		            $posts[] = $cur_post;
	            }

	            $forum_page['item_count'] = 0;
	            $forum_page['item_total'] = count($posts);

	            foreach ($posts as $cur_post)
	            {
		            ++$forum_page['item_count'];

		            $forum_page['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

		            $forum_page['post_ident'] = array();
		            $forum_page['post_ident']['num'] = '<span class="post-num">'.forum_number_format($forum_page['total_post_count'] - $forum_page['item_count'] + 1).'</span>';
		            $forum_page['post_ident']['byline'] = '<span class="post-byline">'.sprintf($lang_post['Post byline'], '<strong>'.forum_htmlencode($cur_post['poster']).'</strong>').'</span>';
		            $forum_page['post_ident']['link'] = '<span class="post-link"><a class="permalink" rel="bookmark" title="'.$lang_post['Permalink post'].'" href="'.forum_link($forum_url['post'], $cur_post['id']).'">'.format_time($cur_post['posted']).'</a></span>';

		            if ($hooks_enable) {
					    ($hook = get_hook('po_topic_review_row_pre_display')) ? eval($hook) : null;	
					} else {
						if (!$forum_user['is_guest'] && $forum_page['item_count'] == 1)
                            $forum_page['post_ident']['ajax-info'] = '<span class="post-ajax-info" cur_post="'.$cur_post['id'].'" last_post="'.$cur_post['id'].'" topic="'.$tid.'" style="display:none;"></span>';
					}
?>
		            <div class="post<?php if ($forum_page['item_count'] == 1) echo ' firstpost'; ?><?php if ($forum_page['item_total'] == $forum_page['item_count']) echo ' lastpost'; ?>">
			            <div class="posthead">
				            <h3 class="hn post-ident"><?php echo implode(' ', $forum_page['post_ident']) ?></h3>
<?php if ($hooks_enable) { ($hook = get_hook('po_topic_review_new_post_head_option')) ? eval($hook) : null; } ?>
			            </div>
			            <div class="postbody">
				            <div class="post-entry">
					            <div class="entry-content">
						            <?php echo $forum_page['message']."\n" ?>
<?php if ($hooks_enable) { ($hook = get_hook('po_topic_review_new_post_entry_data')) ? eval($hook) : null; } ?>
					            </div>
				            </div>
			            </div>
		            </div>
<?php
	            }

				$tpl_temp = forum_trim(ob_get_contents());
				$tpl_main = '<!-- forum_main -->';
			    
				if ($hooks_enable) {
				    ($hook = get_hook('po_end')) ? eval($hook) : null;
				}

				$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
                ob_end_clean();

	            echo json_encode(array('answer'=>2,'posts'=>$tpl_main,'new_posts_count'=>$new_posts_count,'notify'=>$posts_notifications,'last_entry'=>$last_post_date));
				
	            die;
			}
        } else {
		    echo json_encode(array('answer'=>0,'notify'=>$posts_notifications,'last_entry'=>$last_post_date));
				
	        die;
	    }
	} else {
		echo json_encode(array('answer'=>0,'notify'=>$posts_notifications,'last_entry'=>$last_post_date));
				
	    die;
	}
}

function ajax_pu_get_posts_notifications()
{
	global $forum_db, $forum_user, $black_list;

	$query = array(
		'SELECT'	=> 't.forum_id, t.id, t.last_post',
		'FROM'		=> 'topics AS t',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			)
		),
		'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.last_post>'.$forum_user['last_visit'].' AND t.moved_to IS NULL'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$new_topics = array();
	while ($cur_topic = $forum_db->fetch_assoc($result))
		$new_topics[$cur_topic['forum_id']][$cur_topic['id']] = $cur_topic['last_post'];

	$tracked_topics = get_tracked_topics();
	$query = array(
		'SELECT'	=> 'c.id AS cid, c.cat_name, f.id AS fid, f.forum_name, f.forum_desc, f.redirect_url, f.moderators, f.num_topics, f.num_posts, f.last_post, f.last_post_id, f.last_poster, p.poster_id',
		'FROM'		=> 'categories AS c',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'c.id=f.cat_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			),
			array(
				'LEFT JOIN'		=> 'posts AS p',
				'ON'			=> 'p.id=f.last_post_id'
			)
		),
		'WHERE'		=> 'fp.read_forum IS NULL OR fp.read_forum=1',
		'ORDER BY'	=> 'c.disp_position, c.id, f.disp_position'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$new_posts_count = 0;
	while ($cur_forum = $forum_db->fetch_assoc($result))
	{
		// Are there new posts since our last visit?
		if ($cur_forum['last_post'] > $forum_user['last_visit'] && (empty($tracked_topics['forums'][$cur_forum['fid']]) || $cur_forum['last_post'] > $tracked_topics['forums'][$cur_forum['fid']]) && ajax_pu_check_blacklist($cur_forum['poster_id']) == true)
		{
			// There are new posts in this forum, but have we read all of them already?
			foreach ($new_topics[$cur_forum['fid']] as $check_topic_id => $check_last_post)
			{
				if ((empty($tracked_topics['topics'][$check_topic_id]) || $tracked_topics['topics'][$check_topic_id] < $check_last_post) && (empty($tracked_topics['forums'][$cur_forum['fid']]) || $tracked_topics['forums'][$cur_forum['fid']] < $check_last_post))
				{
					$new_posts_count++;
				}
			}
		}
	}

	return $new_posts_count;
}

function ajax_pu_get_new_posts_count() 
{
    global $forum_db, $topic_id, $last_id, $black_list;
		
	$query = array(
	    'SELECT' => 'count(p.id)',
    	'FROM'	 => 'posts AS p',
        'WHERE'	 => 'p.topic_id='.$topic_id.' AND p.id>'.$last_id
    );
	
	if (isset($black_list)) {
		$query['WHERE'] .= ' AND p.poster_id NOT IN ('.implode(',', $black_list).')';
	}
	
    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$new_posts_count = $forum_db->result($result, 0);
	
	return $new_posts_count;
}

function ajax_pu_get_last_post_id()
{
    global $forum_db, $topic_id, $black_list;
	
	$query = array(
    	'SELECT'	=> 'MAX(id) AS last_id',
    	'FROM'		=> 'posts',
		'WHERE'	    => 'topic_id='.$topic_id
    );
	
	if (isset($black_list)) {
		$query['WHERE'] .= ' AND poster_id NOT IN ('.implode(',', $black_list).')';
	}
	
    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$l_entry = $forum_db->fetch_assoc($result);

	return $l_entry['last_id'];
}

function ajax_pu_get_last_post_date() 
{
    global $forum_db, $black_list;
	
	$query = array(
    	'SELECT'	=> 'MAX(posted) AS last_date',
    	'FROM'		=> 'posts'
    );
	
	if (isset($black_list)) {
		$query['WHERE'] = 'poster_id NOT IN ('.implode(',', $black_list).')';
	}
	
    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	if ($forum_db->num_rows($result) > 0) {
	    $l_entry = $forum_db->fetch_assoc($result);
		return $l_entry['last_date'];
	} else {
	    return 0;
	}
}

function ajax_pu_check_blacklist($id) 
{
    global $black_list;
	
	$user_id = isset($id) ? intval($id) : 0;

	if (isset($black_list)) {
		if (in_array($user_id, $black_list))
			return FALSE;
		else
			return TRUE;
	}
	
    return TRUE;
}
